<?php namespace Terrostar\VideosBlockExtension;

use Anomaly\Streams\Platform\Addon\AddonServiceProvider;
use Terrostar\VideosBlockExtension\Block\Contract\BlockRepositoryInterface;
use Terrostar\VideosBlockExtension\Block\BlockRepository;
use Anomaly\Streams\Platform\Model\VideosBlock\VideosBlockBlocksEntryModel;
use Terrostar\VideosBlockExtension\Block\BlockModel;
use Terrostar\VideosBlockExtension\Video\Contract\VideoRepositoryInterface;
use Terrostar\VideosBlockExtension\Video\VideoRepository;
use Anomaly\Streams\Platform\Model\VideosBlock\VideosBlockVideosEntryModel;
use Terrostar\VideosBlockExtension\Video\VideoModel;
use Illuminate\Routing\Router;

class VideosBlockExtensionServiceProvider extends AddonServiceProvider
{

    /**
     * Additional addon plugins.
     *
     * @type array|null
     */
    protected $plugins = [];

    /**
     * The addon Artisan commands.
     *
     * @type array|null
     */
    protected $commands = [];

    /**
     * The addon's scheduled commands.
     *
     * @type array|null
     */
    protected $schedules = [];

    /**
     * The addon API routes.
     *
     * @type array|null
     */
    protected $api = [];

    /**
     * The addon routes.
     *
     * @type array|null
     */
    protected $routes = [];

    /**
     * The addon middleware.
     *
     * @type array|null
     */
    protected $middleware = [
        //Terrostar\VideosBlockExtension\Http\Middleware\ExampleMiddleware::class
    ];

    /**
     * Addon group middleware.
     *
     * @var array
     */
    protected $groupMiddleware = [
        //'web' => [
        //    Terrostar\VideosBlockExtension\Http\Middleware\ExampleMiddleware::class,
        //],
    ];

    /**
     * Addon route middleware.
     *
     * @type array|null
     */
    protected $routeMiddleware = [];

    /**
     * The addon event listeners.
     *
     * @type array|null
     */
    protected $listeners = [
        //Terrostar\VideosBlockExtension\Event\ExampleEvent::class => [
        //    Terrostar\VideosBlockExtension\Listener\ExampleListener::class,
        //],
    ];

    /**
     * The addon alias bindings.
     *
     * @type array|null
     */
    protected $aliases = [
        //'Example' => Terrostar\VideosBlockExtension\Example::class
    ];

    /**
     * The addon class bindings.
     *
     * @type array|null
     */
    protected $bindings = [
        VideosBlockBlocksEntryModel::class => BlockModel::class,
        VideosBlockVideosEntryModel::class => VideoModel::class,
    ];

    /**
     * The addon singleton bindings.
     *
     * @type array|null
     */
    protected $singletons = [
        BlockRepositoryInterface::class => BlockRepository::class,
        VideoRepositoryInterface::class => VideoRepository::class,
    ];

    /**
     * Additional service providers.
     *
     * @type array|null
     */
    protected $providers = [
        //\ExamplePackage\Provider\ExampleProvider::class
    ];

    /**
     * The addon view overrides.
     *
     * @type array|null
     */
    protected $overrides = [
        //'streams::errors/404' => 'module::errors/404',
        //'streams::errors/500' => 'module::errors/500',
    ];

    /**
     * The addon mobile-only view overrides.
     *
     * @type array|null
     */
    protected $mobile = [
        //'streams::errors/404' => 'module::mobile/errors/404',
        //'streams::errors/500' => 'module::mobile/errors/500',
    ];

    /**
     * Register the addon.
     */
    public function register()
    {
        // Run extra pre-boot registration logic here.
        // Use method injection or commands to bring in services.
    }

    /**
     * Boot the addon.
     */
    public function boot()
    {
        // Run extra post-boot registration logic here.
        // Use method injection or commands to bring in services.
    }

    /**
     * Map additional addon routes.
     *
     * @param Router $router
     */
    public function map(Router $router)
    {
        // Register dynamic routes here for example.
        // Use method injection or commands to bring in services.
    }

}
